<center><a href="str.c">Actual source code: str.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:18:52+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSC_DLL</font></strong>
<a name="line2">  2: </a><font color="#B22222">/*</font>
<a name="line3">  3: </a><font color="#B22222">    We define the string operations here. The reason we just do not use </font>
<a name="line4">  4: </a><font color="#B22222">  the standard string routines in the PETSc code is that on some machines </font>
<a name="line5">  5: </a><font color="#B22222">  they are broken or have the wrong prototypes.</font>

<a name="line7">  7: </a><font color="#B22222">*/</font>
<a name="line8"> 8: </a> #include <A href="../../../include/petsc.h.html">petsc.h</A>
<a name="line9"> 9: </a> #include <A href="../../../include/petscsys.h.html">petscsys.h</A>
<a name="line10"> 10: </a><font color="#A020F0">#if defined(PETSC_HAVE_STRING_H)</font>
<a name="line11"> 11: </a><font color="#A020F0">#include &lt;string.h&gt;</font>
<a name="line12"> 12: </a><font color="#A020F0">#endif</font>
<a name="line13"> 13: </a><font color="#A020F0">#if defined(PETSC_HAVE_STRINGS_H)</font>
<a name="line14"> 14: </a><font color="#A020F0">#include &lt;strings.h&gt;</font>
<a name="line15"> 15: </a><font color="#A020F0">#endif</font>
<a name="line16"> 16: </a><font color="#A020F0">#include </font><font color="#666666">"petscfix.h"</font><font color="#A020F0"></font>

<a name="line20"> 20: </a><font color="#B22222">/*@C</font>
<a name="line21"> 21: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A> - Gets length of a string</font>

<a name="line23"> 23: </a><font color="#B22222">   Not Collective</font>

<a name="line25"> 25: </a><font color="#B22222">   Input Parameters:</font>
<a name="line26"> 26: </a><font color="#B22222">.  s - pointer to string</font>

<a name="line28"> 28: </a><font color="#B22222">   Output Parameter:</font>
<a name="line29"> 29: </a><font color="#B22222">.  len - length in bytes</font>

<a name="line31"> 31: </a><font color="#B22222">   Level: intermediate</font>

<a name="line33"> 33: </a><font color="#B22222">   Note:</font>
<a name="line34"> 34: </a><font color="#B22222">   This routine is analogous to strlen().</font>

<a name="line36"> 36: </a><font color="#B22222">   Null string returns a length of zero</font>

<a name="line38"> 38: </a><font color="#B22222">  Concepts: string length</font>
<a name="line39"> 39: </a><font color="#B22222">  </font>
<a name="line40"> 40: </a><font color="#B22222">@*/</font>
<a name="line41"> 41: </a><strong><font color="#4169E1"><a name="PetscStrlen"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(const char s[],size_t *len)</font></strong>
<a name="line42"> 42: </a>{
<a name="line44"> 44: </a>  <font color="#4169E1">if</font> (!s) {
<a name="line45"> 45: </a>    *len = 0;
<a name="line46"> 46: </a>  } <font color="#4169E1">else</font> {
<a name="line47"> 47: </a>    *len = strlen(s);
<a name="line48"> 48: </a>  }
<a name="line49"> 49: </a>  <font color="#4169E1">return</font>(0);
<a name="line50"> 50: </a>}

<a name="line54"> 54: </a><font color="#B22222">/*@C</font>
<a name="line55"> 55: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrallocpy.html#PetscStrallocpy">PetscStrallocpy</A> - Allocates space to hold a copy of a string then copies the string</font>

<a name="line57"> 57: </a><font color="#B22222">   Not Collective</font>

<a name="line59"> 59: </a><font color="#B22222">   Input Parameters:</font>
<a name="line60"> 60: </a><font color="#B22222">.  s - pointer to string</font>

<a name="line62"> 62: </a><font color="#B22222">   Output Parameter:</font>
<a name="line63"> 63: </a><font color="#B22222">.  t - the copied string</font>

<a name="line65"> 65: </a><font color="#B22222">   Level: intermediate</font>

<a name="line67"> 67: </a><font color="#B22222">   Note:</font>
<a name="line68"> 68: </a><font color="#B22222">      Null string returns a new null string</font>

<a name="line70"> 70: </a><font color="#B22222">  Concepts: string copy</font>
<a name="line71"> 71: </a><font color="#B22222">  </font>
<a name="line72"> 72: </a><font color="#B22222">@*/</font>
<a name="line73"> 73: </a><strong><font color="#4169E1"><a name="PetscStrallocpy"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrallocpy.html#PetscStrallocpy">PetscStrallocpy</A>(const char s[],char *t[])</font></strong>
<a name="line74"> 74: </a>{
<a name="line76"> 76: </a>  size_t         len;
<a name="line77"> 77: </a>  char           *tmp = 0;

<a name="line80"> 80: </a>  <font color="#4169E1">if</font> (s) {
<a name="line81"> 81: </a>    <A href="../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(s,&amp;len);
<a name="line82"> 82: </a>    <A href="../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((1+len)*<font color="#4169E1">sizeof</font>(char),&amp;tmp);
<a name="line83"> 83: </a>    <A href="../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(tmp,s);
<a name="line84"> 84: </a>  }
<a name="line85"> 85: </a>  *t = tmp;
<a name="line86"> 86: </a>  <font color="#4169E1">return</font>(0);
<a name="line87"> 87: </a>}

<a name="line91"> 91: </a><font color="#B22222">/*@C</font>
<a name="line92"> 92: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A> - Copies a string</font>

<a name="line94"> 94: </a><font color="#B22222">   Not Collective</font>

<a name="line96"> 96: </a><font color="#B22222">   Input Parameters:</font>
<a name="line97"> 97: </a><font color="#B22222">.  t - pointer to string</font>

<a name="line99"> 99: </a><font color="#B22222">   Output Parameter:</font>
<a name="line100">100: </a><font color="#B22222">.  s - the copied string</font>

<a name="line102">102: </a><font color="#B22222">   Level: intermediate</font>

<a name="line104">104: </a><font color="#B22222">   Note:</font>
<a name="line105">105: </a><font color="#B22222">     Null string returns a string starting with zero</font>

<a name="line107">107: </a><font color="#B22222">  Concepts: string copy</font>
<a name="line108">108: </a><font color="#B22222">  </font>
<a name="line109">109: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscStrncpy.html#PetscStrncpy">PetscStrncpy</A>(), <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(), <A href="../../../docs/manualpages/Sys/PetscStrncat.html#PetscStrncat">PetscStrncat</A>()</font>

<a name="line111">111: </a><font color="#B22222">@*/</font>
<a name="line112">112: </a><strong><font color="#4169E1"><a name="PetscStrcpy"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(char s[],const char t[])</font></strong>
<a name="line113">113: </a>{
<a name="line115">115: </a>  <font color="#4169E1">if</font> (t &amp;&amp; !s) {
<a name="line116">116: </a>    <A href="../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_NULL,<font color="#666666">"Trying to copy string into null pointer"</font>);
<a name="line117">117: </a>  }
<a name="line118">118: </a>  <font color="#4169E1">if</font> (t) {strcpy(s,t);}
<a name="line119">119: </a>  <font color="#4169E1">else</font> <font color="#4169E1">if</font> (s) {s[0] = 0;}
<a name="line120">120: </a>  <font color="#4169E1">return</font>(0);
<a name="line121">121: </a>}

<a name="line125">125: </a><font color="#B22222">/*@C</font>
<a name="line126">126: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrncpy.html#PetscStrncpy">PetscStrncpy</A> - Copies a string up to a certain length</font>

<a name="line128">128: </a><font color="#B22222">   Not Collective</font>

<a name="line130">130: </a><font color="#B22222">   Input Parameters:</font>
<a name="line131">131: </a><font color="#B22222">+  t - pointer to string</font>
<a name="line132">132: </a><font color="#B22222">-  n - the length to copy</font>

<a name="line134">134: </a><font color="#B22222">   Output Parameter:</font>
<a name="line135">135: </a><font color="#B22222">.  s - the copied string</font>

<a name="line137">137: </a><font color="#B22222">   Level: intermediate</font>

<a name="line139">139: </a><font color="#B22222">   Note:</font>
<a name="line140">140: </a><font color="#B22222">     Null string returns a string starting with zero</font>

<a name="line142">142: </a><font color="#B22222">  Concepts: string copy</font>

<a name="line144">144: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(), <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(), <A href="../../../docs/manualpages/Sys/PetscStrncat.html#PetscStrncat">PetscStrncat</A>()</font>
<a name="line145">145: </a><font color="#B22222">  </font>
<a name="line146">146: </a><font color="#B22222">@*/</font>
<a name="line147">147: </a><strong><font color="#4169E1"><a name="PetscStrncpy"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrncpy.html#PetscStrncpy">PetscStrncpy</A>(char s[],const char t[],size_t n)</font></strong>
<a name="line148">148: </a>{
<a name="line150">150: </a>  <font color="#4169E1">if</font> (t &amp;&amp; !s) {
<a name="line151">151: </a>    <A href="../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_NULL,<font color="#666666">"Trying to copy string into null pointer"</font>);
<a name="line152">152: </a>  }
<a name="line153">153: </a>  <font color="#4169E1">if</font> (t) {strncpy(s,t,n);}
<a name="line154">154: </a>  <font color="#4169E1">else</font> <font color="#4169E1">if</font> (s) {s[0] = 0;}
<a name="line155">155: </a>  <font color="#4169E1">return</font>(0);
<a name="line156">156: </a>}

<a name="line160">160: </a><font color="#B22222">/*@C</font>
<a name="line161">161: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A> - Concatenates a string onto a given string</font>

<a name="line163">163: </a><font color="#B22222">   Not Collective</font>

<a name="line165">165: </a><font color="#B22222">   Input Parameters:</font>
<a name="line166">166: </a><font color="#B22222">+  s - string to be added to</font>
<a name="line167">167: </a><font color="#B22222">-  t - pointer to string to be added to end</font>

<a name="line169">169: </a><font color="#B22222">   Level: intermediate</font>

<a name="line171">171: </a><font color="#B22222">  Concepts: string copy</font>

<a name="line173">173: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(), <A href="../../../docs/manualpages/Sys/PetscStrncpy.html#PetscStrncpy">PetscStrncpy</A>(), <A href="../../../docs/manualpages/Sys/PetscStrncat.html#PetscStrncat">PetscStrncat</A>()</font>
<a name="line174">174: </a><font color="#B22222">  </font>
<a name="line175">175: </a><font color="#B22222">@*/</font>
<a name="line176">176: </a><strong><font color="#4169E1"><a name="PetscStrcat"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(char s[],const char t[])</font></strong>
<a name="line177">177: </a>{
<a name="line179">179: </a>  strcat(s,t);
<a name="line180">180: </a>  <font color="#4169E1">return</font>(0);
<a name="line181">181: </a>}

<a name="line185">185: </a><font color="#B22222">/*@C</font>
<a name="line186">186: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrncat.html#PetscStrncat">PetscStrncat</A> - Concatenates a string onto a given string, up to a given length</font>

<a name="line188">188: </a><font color="#B22222">   Not Collective</font>

<a name="line190">190: </a><font color="#B22222">   Input Parameters:</font>
<a name="line191">191: </a><font color="#B22222">+  s - pointer to string to be added to end</font>
<a name="line192">192: </a><font color="#B22222">.  t - string to be added to</font>
<a name="line193">193: </a><font color="#B22222">.  n - maximum length to copy </font>

<a name="line195">195: </a><font color="#B22222">   Level: intermediate</font>

<a name="line197">197: </a><font color="#B22222">  Concepts: string copy</font>

<a name="line199">199: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(), <A href="../../../docs/manualpages/Sys/PetscStrncpy.html#PetscStrncpy">PetscStrncpy</A>(), <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>()</font>
<a name="line200">200: </a><font color="#B22222">  </font>
<a name="line201">201: </a><font color="#B22222">@*/</font>
<a name="line202">202: </a><strong><font color="#4169E1"><a name="PetscStrncat"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrncat.html#PetscStrncat">PetscStrncat</A>(char s[],const char t[],size_t n)</font></strong>
<a name="line203">203: </a>{
<a name="line205">205: </a>  strncat(s,t,n);
<a name="line206">206: </a>  <font color="#4169E1">return</font>(0);
<a name="line207">207: </a>}

<a name="line211">211: </a><font color="#B22222">/*@C</font>
<a name="line212">212: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrcmp.html#PetscStrcmp">PetscStrcmp</A> - Compares two strings,</font>

<a name="line214">214: </a><font color="#B22222">   Not Collective</font>

<a name="line216">216: </a><font color="#B22222">   Input Parameters:</font>
<a name="line217">217: </a><font color="#B22222">+  a - pointer to string first string</font>
<a name="line218">218: </a><font color="#B22222">-  b - pointer to second string</font>

<a name="line220">220: </a><font color="#B22222">   Output Parameter:</font>
<a name="line221">221: </a><font color="#B22222">.  flg - if the two strings are equal</font>

<a name="line223">223: </a><font color="#B22222">   Level: intermediate</font>

<a name="line225">225: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscStrgrt.html#PetscStrgrt">PetscStrgrt</A>(), <A href="../../../docs/manualpages/Sys/PetscStrncmp.html#PetscStrncmp">PetscStrncmp</A>(), <A href="../../../docs/manualpages/Sys/PetscStrcasecmp.html#PetscStrcasecmp">PetscStrcasecmp</A>()</font>

<a name="line227">227: </a><font color="#B22222">@*/</font>
<a name="line228">228: </a><strong><font color="#4169E1"><a name="PetscStrcmp"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrcmp.html#PetscStrcmp">PetscStrcmp</A>(const char a[],const char b[],<A href="../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> *flg)</font></strong>
<a name="line229">229: </a>{
<a name="line230">230: </a>  int c;

<a name="line233">233: </a>  <font color="#4169E1">if</font> (!a &amp;&amp; !b) {
<a name="line234">234: </a>    *flg = <A href="../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line235">235: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (!a || !b) {
<a name="line236">236: </a>    *flg = <A href="../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line237">237: </a>  } <font color="#4169E1">else</font> {
<a name="line238">238: </a>    c = strcmp(a,b);
<a name="line239">239: </a>    <font color="#4169E1">if</font> (c) *flg = <A href="../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line240">240: </a>    <font color="#4169E1">else</font>   *flg = <A href="../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line241">241: </a>  }
<a name="line242">242: </a>  <font color="#4169E1">return</font>(0);
<a name="line243">243: </a>}

<a name="line247">247: </a><font color="#B22222">/*@C</font>
<a name="line248">248: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrgrt.html#PetscStrgrt">PetscStrgrt</A> - If first string is greater than the second</font>

<a name="line250">250: </a><font color="#B22222">   Not Collective</font>

<a name="line252">252: </a><font color="#B22222">   Input Parameters:</font>
<a name="line253">253: </a><font color="#B22222">+  a - pointer to first string</font>
<a name="line254">254: </a><font color="#B22222">-  b - pointer to second string</font>

<a name="line256">256: </a><font color="#B22222">   Output Parameter:</font>
<a name="line257">257: </a><font color="#B22222">.  flg - if the first string is greater</font>

<a name="line259">259: </a><font color="#B22222">   Notes:</font>
<a name="line260">260: </a><font color="#B22222">    Null arguments are ok, a null string is considered smaller than </font>
<a name="line261">261: </a><font color="#B22222">    all others</font>

<a name="line263">263: </a><font color="#B22222">   Level: intermediate</font>

<a name="line265">265: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscStrcmp.html#PetscStrcmp">PetscStrcmp</A>(), <A href="../../../docs/manualpages/Sys/PetscStrncmp.html#PetscStrncmp">PetscStrncmp</A>(), <A href="../../../docs/manualpages/Sys/PetscStrcasecmp.html#PetscStrcasecmp">PetscStrcasecmp</A>()</font>

<a name="line267">267: </a><font color="#B22222">@*/</font>
<a name="line268">268: </a><strong><font color="#4169E1"><a name="PetscStrgrt"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrgrt.html#PetscStrgrt">PetscStrgrt</A>(const char a[],const char b[],<A href="../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> *t)</font></strong>
<a name="line269">269: </a>{
<a name="line270">270: </a>  int c;

<a name="line273">273: </a>  <font color="#4169E1">if</font> (!a &amp;&amp; !b) {
<a name="line274">274: </a>    *t = <A href="../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line275">275: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (a &amp;&amp; !b) {
<a name="line276">276: </a>    *t = <A href="../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line277">277: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (!a &amp;&amp; b) {
<a name="line278">278: </a>    *t = <A href="../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line279">279: </a>  } <font color="#4169E1">else</font> {
<a name="line280">280: </a>    c = strcmp(a,b);
<a name="line281">281: </a>    <font color="#4169E1">if</font> (c &gt; 0) *t = <A href="../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line282">282: </a>    <font color="#4169E1">else</font>       *t = <A href="../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line283">283: </a>  }
<a name="line284">284: </a>  <font color="#4169E1">return</font>(0);
<a name="line285">285: </a>}

<a name="line289">289: </a><font color="#B22222">/*@C</font>
<a name="line290">290: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrcasecmp.html#PetscStrcasecmp">PetscStrcasecmp</A> - Returns true if the two strings are the same</font>
<a name="line291">291: </a><font color="#B22222">     except possibly for case.</font>

<a name="line293">293: </a><font color="#B22222">   Not Collective</font>

<a name="line295">295: </a><font color="#B22222">   Input Parameters:</font>
<a name="line296">296: </a><font color="#B22222">+  a - pointer to first string</font>
<a name="line297">297: </a><font color="#B22222">-  b - pointer to second string</font>

<a name="line299">299: </a><font color="#B22222">   Output Parameter:</font>
<a name="line300">300: </a><font color="#B22222">.  flg - if the two strings are the same</font>

<a name="line302">302: </a><font color="#B22222">   Notes:</font>
<a name="line303">303: </a><font color="#B22222">    Null arguments are ok</font>

<a name="line305">305: </a><font color="#B22222">   Level: intermediate</font>

<a name="line307">307: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscStrcmp.html#PetscStrcmp">PetscStrcmp</A>(), <A href="../../../docs/manualpages/Sys/PetscStrncmp.html#PetscStrncmp">PetscStrncmp</A>(), <A href="../../../docs/manualpages/Sys/PetscStrgrt.html#PetscStrgrt">PetscStrgrt</A>()</font>

<a name="line309">309: </a><font color="#B22222">@*/</font>
<a name="line310">310: </a><strong><font color="#4169E1"><a name="PetscStrcasecmp"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrcasecmp.html#PetscStrcasecmp">PetscStrcasecmp</A>(const char a[],const char b[],<A href="../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> *t)</font></strong>
<a name="line311">311: </a>{
<a name="line312">312: </a>  int c;

<a name="line315">315: </a>  <font color="#4169E1">if</font> (!a &amp;&amp; !b) c = 0;
<a name="line316">316: </a>  <font color="#4169E1">else</font> <font color="#4169E1">if</font> (!a || !b) c = 1;
<a name="line317">317: </a><font color="#A020F0">#if defined(PETSC_HAVE_STRICMP)</font>
<a name="line318">318: </a>  <font color="#4169E1">else</font> c = stricmp(a,b);
<a name="line319">319: </a><font color="#A020F0">#else</font>
<a name="line320">320: </a>  <font color="#4169E1">else</font> c = strcasecmp(a,b);
<a name="line321">321: </a><font color="#A020F0">#endif</font>
<a name="line322">322: </a>  <font color="#4169E1">if</font> (!c) *t = <A href="../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line323">323: </a>  <font color="#4169E1">else</font>    *t = <A href="../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line324">324: </a>  <font color="#4169E1">return</font>(0);
<a name="line325">325: </a>}

<a name="line329">329: </a><font color="#B22222">/*@C</font>
<a name="line330">330: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrncmp.html#PetscStrncmp">PetscStrncmp</A> - Compares two strings, up to a certain length</font>

<a name="line332">332: </a><font color="#B22222">   Not Collective</font>

<a name="line334">334: </a><font color="#B22222">   Input Parameters:</font>
<a name="line335">335: </a><font color="#B22222">+  a - pointer to first string</font>
<a name="line336">336: </a><font color="#B22222">.  b - pointer to second string</font>
<a name="line337">337: </a><font color="#B22222">-  n - length to compare up to</font>

<a name="line339">339: </a><font color="#B22222">   Output Parameter:</font>
<a name="line340">340: </a><font color="#B22222">.  t - if the two strings are equal</font>

<a name="line342">342: </a><font color="#B22222">   Level: intermediate</font>

<a name="line344">344: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscStrgrt.html#PetscStrgrt">PetscStrgrt</A>(), <A href="../../../docs/manualpages/Sys/PetscStrcmp.html#PetscStrcmp">PetscStrcmp</A>(), <A href="../../../docs/manualpages/Sys/PetscStrcasecmp.html#PetscStrcasecmp">PetscStrcasecmp</A>()</font>

<a name="line346">346: </a><font color="#B22222">@*/</font>
<a name="line347">347: </a><strong><font color="#4169E1"><a name="PetscStrncmp"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrncmp.html#PetscStrncmp">PetscStrncmp</A>(const char a[],const char b[],size_t n,<A href="../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> *t)</font></strong>
<a name="line348">348: </a>{
<a name="line349">349: </a>  int c;

<a name="line352">352: </a>  c = strncmp(a,b,n);
<a name="line353">353: </a>  <font color="#4169E1">if</font> (!c) *t = <A href="../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line354">354: </a>  <font color="#4169E1">else</font>    *t = <A href="../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line355">355: </a>  <font color="#4169E1">return</font>(0);
<a name="line356">356: </a>}

<a name="line360">360: </a><font color="#B22222">/*@C</font>
<a name="line361">361: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrchr.html#PetscStrchr">PetscStrchr</A> - Locates first occurance of a character in a string</font>

<a name="line363">363: </a><font color="#B22222">   Not Collective</font>

<a name="line365">365: </a><font color="#B22222">   Input Parameters:</font>
<a name="line366">366: </a><font color="#B22222">+  a - pointer to string</font>
<a name="line367">367: </a><font color="#B22222">-  b - character</font>

<a name="line369">369: </a><font color="#B22222">   Output Parameter:</font>
<a name="line370">370: </a><font color="#B22222">.  c - location of occurance, <A href="../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A> if not found</font>

<a name="line372">372: </a><font color="#B22222">   Level: intermediate</font>

<a name="line374">374: </a><font color="#B22222">@*/</font>
<a name="line375">375: </a><strong><font color="#4169E1"><a name="PetscStrchr"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrchr.html#PetscStrchr">PetscStrchr</A>(const char a[],char b,char *c[])</font></strong>
<a name="line376">376: </a>{
<a name="line378">378: </a>  *c = (char *)strchr(a,b);
<a name="line379">379: </a>  <font color="#4169E1">return</font>(0);
<a name="line380">380: </a>}

<a name="line384">384: </a><font color="#B22222">/*@C</font>
<a name="line385">385: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrrchr.html#PetscStrrchr">PetscStrrchr</A> - Locates one location past the last occurance of a character in a string,</font>
<a name="line386">386: </a><font color="#B22222">      if the character is not found then returns entire string</font>

<a name="line388">388: </a><font color="#B22222">   Not Collective</font>

<a name="line390">390: </a><font color="#B22222">   Input Parameters:</font>
<a name="line391">391: </a><font color="#B22222">+  a - pointer to string</font>
<a name="line392">392: </a><font color="#B22222">-  b - character</font>

<a name="line394">394: </a><font color="#B22222">   Output Parameter:</font>
<a name="line395">395: </a><font color="#B22222">.  tmp - location of occurance, a if not found</font>

<a name="line397">397: </a><font color="#B22222">   Level: intermediate</font>

<a name="line399">399: </a><font color="#B22222">@*/</font>
<a name="line400">400: </a><strong><font color="#4169E1"><a name="PetscStrrchr"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrrchr.html#PetscStrrchr">PetscStrrchr</A>(const char a[],char b,char *tmp[])</font></strong>
<a name="line401">401: </a>{
<a name="line403">403: </a>  *tmp = (char *)strrchr(a,b);
<a name="line404">404: </a>  <font color="#4169E1">if</font> (!*tmp) *tmp = (char*)a; <font color="#4169E1">else</font> *tmp = *tmp + 1;
<a name="line405">405: </a>  <font color="#4169E1">return</font>(0);
<a name="line406">406: </a>}

<a name="line410">410: </a><font color="#B22222">/*@C</font>
<a name="line411">411: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrtolower.html#PetscStrtolower">PetscStrtolower</A> - Converts string to lower case</font>

<a name="line413">413: </a><font color="#B22222">   Not Collective</font>

<a name="line415">415: </a><font color="#B22222">   Input Parameters:</font>
<a name="line416">416: </a><font color="#B22222">.  a - pointer to string</font>

<a name="line418">418: </a><font color="#B22222">   Level: intermediate</font>

<a name="line420">420: </a><font color="#B22222">@*/</font>
<a name="line421">421: </a><strong><font color="#4169E1"><a name="PetscStrtolower"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrtolower.html#PetscStrtolower">PetscStrtolower</A>(char a[])</font></strong>
<a name="line422">422: </a>{
<a name="line424">424: </a>  <font color="#4169E1">while</font> (*a) {
<a name="line425">425: </a>    <font color="#4169E1">if</font> (*a &gt;= 'A' &amp;&amp; *a &lt;= 'Z') *a += 'a' - 'A';
<a name="line426">426: </a>    a++;
<a name="line427">427: </a>  }
<a name="line428">428: </a>  <font color="#4169E1">return</font>(0);
<a name="line429">429: </a>}

<a name="line433">433: </a><font color="#B22222">/*@C</font>
<a name="line434">434: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscTokenFind.html#PetscTokenFind">PetscTokenFind</A> - Locates next "token" in a string</font>

<a name="line436">436: </a><font color="#B22222">   Not Collective</font>

<a name="line438">438: </a><font color="#B22222">   Input Parameters:</font>
<a name="line439">439: </a><font color="#B22222">.  a - pointer to token</font>

<a name="line441">441: </a><font color="#B22222">   Output Parameter:</font>
<a name="line442">442: </a><font color="#B22222">.  result - location of occurance, <A href="../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A> if not found</font>

<a name="line444">444: </a><font color="#B22222">   Notes:</font>

<a name="line446">446: </a><font color="#B22222">     This version is different from the system version in that</font>
<a name="line447">447: </a><font color="#B22222">  it allows you to pass a read-only string into the function.</font>

<a name="line449">449: </a><font color="#B22222">   Level: intermediate</font>

<a name="line451">451: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscTokenCreate.html#PetscTokenCreate">PetscTokenCreate</A>(), <A href="../../../docs/manualpages/Sys/PetscTokenDestroy.html#PetscTokenDestroy">PetscTokenDestroy</A>()</font>
<a name="line452">452: </a><font color="#B22222">@*/</font>
<a name="line453">453: </a><strong><font color="#4169E1"><a name="PetscTokenFind"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscTokenFind.html#PetscTokenFind">PetscTokenFind</A>(<A href="../../../docs/manualpages/Sys/PetscToken.html#PetscToken">PetscToken</A> *a,char *result[])</font></strong>
<a name="line454">454: </a>{
<a name="line455">455: </a>  char *ptr = a-&gt;current;

<a name="line458">458: </a>  *result = a-&gt;current;
<a name="line459">459: </a>  <font color="#4169E1">if</font> (ptr &amp;&amp; !*ptr) *result = 0;
<a name="line460">460: </a>  <font color="#4169E1">while</font> (ptr) {
<a name="line461">461: </a>    <font color="#4169E1">if</font> (*ptr == a-&gt;token) {
<a name="line462">462: </a>      *ptr++ = 0;
<a name="line463">463: </a>      <font color="#4169E1">while</font> (*ptr == a-&gt;token) ptr++;
<a name="line464">464: </a>      a-&gt;current = ptr;
<a name="line465">465: </a>      <font color="#4169E1">break</font>;
<a name="line466">466: </a>    }
<a name="line467">467: </a>    <font color="#4169E1">if</font> (!*ptr) {
<a name="line468">468: </a>      a-&gt;current = 0;
<a name="line469">469: </a>      <font color="#4169E1">break</font>;
<a name="line470">470: </a>    }
<a name="line471">471: </a>    ptr++;
<a name="line472">472: </a>  }
<a name="line473">473: </a>  <font color="#4169E1">return</font>(0);
<a name="line474">474: </a>}

<a name="line478">478: </a><font color="#B22222">/*@C</font>
<a name="line479">479: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscTokenCreate.html#PetscTokenCreate">PetscTokenCreate</A> - Creates a <A href="../../../docs/manualpages/Sys/PetscToken.html#PetscToken">PetscToken</A> used to find tokens in a string</font>

<a name="line481">481: </a><font color="#B22222">   Not Collective</font>

<a name="line483">483: </a><font color="#B22222">   Input Parameters:</font>
<a name="line484">484: </a><font color="#B22222">+  string - the string to look in</font>
<a name="line485">485: </a><font color="#B22222">-  token - the character to look for</font>

<a name="line487">487: </a><font color="#B22222">   Output Parameter:</font>
<a name="line488">488: </a><font color="#B22222">.  a - pointer to token</font>

<a name="line490">490: </a><font color="#B22222">   Notes:</font>

<a name="line492">492: </a><font color="#B22222">     This version is different from the system version in that</font>
<a name="line493">493: </a><font color="#B22222">  it allows you to pass a read-only string into the function.</font>

<a name="line495">495: </a><font color="#B22222">   Level: intermediate</font>

<a name="line497">497: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscTokenFind.html#PetscTokenFind">PetscTokenFind</A>(), <A href="../../../docs/manualpages/Sys/PetscTokenDestroy.html#PetscTokenDestroy">PetscTokenDestroy</A>()</font>
<a name="line498">498: </a><font color="#B22222">@*/</font>
<a name="line499">499: </a><strong><font color="#4169E1"><a name="PetscTokenCreate"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscTokenCreate.html#PetscTokenCreate">PetscTokenCreate</A>(const char a[],const char b,<A href="../../../docs/manualpages/Sys/PetscToken.html#PetscToken">PetscToken</A> **t)</font></strong>
<a name="line500">500: </a>{
<a name="line502">502: </a>  size_t         len;

<a name="line505">505: </a>  <A href="../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(<A href="../../../docs/manualpages/Sys/PetscToken.html#PetscToken">PetscToken</A>,t);
<a name="line506">506: </a>  <A href="../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(a,&amp;len);
<a name="line507">507: </a>  <A href="../../../docs/manualpages/Sys/PetscStrallocpy.html#PetscStrallocpy">PetscStrallocpy</A>(a,&amp;(*t)-&gt;array);
<a name="line508">508: </a>  (*t)-&gt;current = (*t)-&gt;array;
<a name="line509">509: </a>  (*t)-&gt;token   = b;
<a name="line510">510: </a>  <font color="#4169E1">return</font>(0);
<a name="line511">511: </a>}

<a name="line515">515: </a><font color="#B22222">/*@C</font>
<a name="line516">516: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscTokenDestroy.html#PetscTokenDestroy">PetscTokenDestroy</A> - Destroys a <A href="../../../docs/manualpages/Sys/PetscToken.html#PetscToken">PetscToken</A></font>

<a name="line518">518: </a><font color="#B22222">   Not Collective</font>

<a name="line520">520: </a><font color="#B22222">   Input Parameters:</font>
<a name="line521">521: </a><font color="#B22222">.  a - pointer to token</font>

<a name="line523">523: </a><font color="#B22222">   Level: intermediate</font>

<a name="line525">525: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscTokenCreate.html#PetscTokenCreate">PetscTokenCreate</A>(), <A href="../../../docs/manualpages/Sys/PetscTokenFind.html#PetscTokenFind">PetscTokenFind</A>()</font>
<a name="line526">526: </a><font color="#B22222">@*/</font>
<a name="line527">527: </a><strong><font color="#4169E1"><a name="PetscTokenDestroy"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscTokenDestroy.html#PetscTokenDestroy">PetscTokenDestroy</A>(<A href="../../../docs/manualpages/Sys/PetscToken.html#PetscToken">PetscToken</A> *a)</font></strong>
<a name="line528">528: </a>{

<a name="line532">532: </a>  <A href="../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(a-&gt;array);
<a name="line533">533: </a>  <A href="../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(a);
<a name="line534">534: </a>  <font color="#4169E1">return</font>(0);
<a name="line535">535: </a>}

<a name="line539">539: </a><font color="#B22222">/*@C</font>
<a name="line540">540: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrrstr.html#PetscStrrstr">PetscStrrstr</A> - Locates last occurance of string in another string</font>

<a name="line542">542: </a><font color="#B22222">   Not Collective</font>

<a name="line544">544: </a><font color="#B22222">   Input Parameters:</font>
<a name="line545">545: </a><font color="#B22222">+  a - pointer to string</font>
<a name="line546">546: </a><font color="#B22222">-  b - string to find</font>

<a name="line548">548: </a><font color="#B22222">   Output Parameter:</font>
<a name="line549">549: </a><font color="#B22222">.  tmp - location of occurance</font>

<a name="line551">551: </a><font color="#B22222">   Level: intermediate</font>

<a name="line553">553: </a><font color="#B22222">@*/</font>
<a name="line554">554: </a><strong><font color="#4169E1"><a name="PetscStrrstr"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrrstr.html#PetscStrrstr">PetscStrrstr</A>(const char a[],const char b[],char *tmp[])</font></strong>
<a name="line555">555: </a>{
<a name="line556">556: </a>  const char *stmp = a, *ltmp = 0;

<a name="line559">559: </a>  <font color="#4169E1">while</font> (stmp) {
<a name="line560">560: </a>    stmp = (char *)strstr(stmp,b);
<a name="line561">561: </a>    <font color="#4169E1">if</font> (stmp) {ltmp = stmp;stmp++;}
<a name="line562">562: </a>  }
<a name="line563">563: </a>  *tmp = (char *)ltmp;
<a name="line564">564: </a>  <font color="#4169E1">return</font>(0);
<a name="line565">565: </a>}

<a name="line569">569: </a><font color="#B22222">/*@C</font>
<a name="line570">570: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A> - Locates first occurance of string in another string</font>

<a name="line572">572: </a><font color="#B22222">   Not Collective</font>

<a name="line574">574: </a><font color="#B22222">   Input Parameters:</font>
<a name="line575">575: </a><font color="#B22222">+  a - pointer to string</font>
<a name="line576">576: </a><font color="#B22222">-  b - string to find</font>

<a name="line578">578: </a><font color="#B22222">   Output Parameter:</font>
<a name="line579">579: </a><font color="#B22222">.  tmp - location of occurance</font>

<a name="line581">581: </a><font color="#B22222">   Level: intermediate</font>

<a name="line583">583: </a><font color="#B22222">@*/</font>
<a name="line584">584: </a><strong><font color="#4169E1"><a name="PetscStrstr"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(const char a[],const char b[],char *tmp[])</font></strong>
<a name="line585">585: </a>{
<a name="line587">587: </a>  *tmp = (char *)strstr(a,b);
<a name="line588">588: </a>  <font color="#4169E1">return</font>(0);
<a name="line589">589: </a>}

<a name="line593">593: </a><font color="#B22222">/*@C</font>
<a name="line594">594: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscGetPetscDir.html#PetscGetPetscDir">PetscGetPetscDir</A> - Gets the directory PETSc is installed in</font>

<a name="line596">596: </a><font color="#B22222">   Not Collective</font>

<a name="line598">598: </a><font color="#B22222">   Output Parameter:</font>
<a name="line599">599: </a><font color="#B22222">.  dir - the directory</font>

<a name="line601">601: </a><font color="#B22222">   Level: developer</font>

<a name="line603">603: </a><font color="#B22222">@*/</font>
<a name="line604">604: </a><strong><font color="#4169E1"><a name="PetscGetPetscDir"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscGetPetscDir.html#PetscGetPetscDir">PetscGetPetscDir</A>(const char *dir[])</font></strong>
<a name="line605">605: </a>{
<a name="line607">607: </a>  *dir = PETSC_DIR;
<a name="line608">608: </a>  <font color="#4169E1">return</font>(0);
<a name="line609">609: </a>}

<a name="line613">613: </a><font color="#B22222">/*@C</font>
<a name="line614">614: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrreplace.html#PetscStrreplace">PetscStrreplace</A> - Replaces substrings in string with other substrings</font>

<a name="line616">616: </a><font color="#B22222">   Not Collective</font>

<a name="line618">618: </a><font color="#B22222">   Input Parameters:</font>
<a name="line619">619: </a><font color="#B22222">+   <A href="../../../docs/manualpages/Sys/comm.html#comm">comm</A> - <A href="../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A> of processors that are processing the string</font>
<a name="line620">620: </a><font color="#B22222">.   aa - the string to look in</font>
<a name="line621">621: </a><font color="#B22222">.   b - the resulting copy of a with replaced strings (b can be the same as a)</font>
<a name="line622">622: </a><font color="#B22222">-   len - the length of b</font>

<a name="line624">624: </a><font color="#B22222">   Notes:</font>
<a name="line625">625: </a><font color="#B22222">      Replaces   ${PETSC_ARCH},${PETSC_DIR},${PETSC_LIB_DIR},${DISPLAY},</font>
<a name="line626">626: </a><font color="#B22222">      ${HOMEDIRECTORY},${WORKINGDIRECTORY},${USERNAME} with appropriate values</font>
<a name="line627">627: </a><font color="#B22222">      as well as any environmental variables.</font>
<a name="line628">628: </a><font color="#B22222">   </font>
<a name="line629">629: </a><font color="#B22222">   Level: intermediate</font>

<a name="line631">631: </a><font color="#B22222">@*/</font>
<a name="line632">632: </a><strong><font color="#4169E1"><a name="PetscStrreplace"></a><A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../docs/manualpages/Sys/PetscStrreplace.html#PetscStrreplace">PetscStrreplace</A>(<A href="../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A> <A href="../../../docs/manualpages/Sys/comm.html#comm">comm</A>,const char aa[],char b[],size_t len)</font></strong>
<a name="line633">633: </a>{
<a name="line635">635: </a>  int            i = 0;
<a name="line636">636: </a>  size_t         l,l1,l2,l3;
<a name="line637">637: </a>  char           *work,*par,*epar,env[1024],*tfree,*a = (char*)aa;
<a name="line638">638: </a>  const char     *s[] = {<font color="#666666">"${PETSC_ARCH}"</font>,<font color="#666666">"${PETSC_DIR}"</font>,<font color="#666666">"${PETSC_LIB_DIR}"</font>,<font color="#666666">"${DISPLAY}"</font>,<font color="#666666">"${HOMEDIRECTORY}"</font>,<font color="#666666">"${WORKINGDIRECTORY}"</font>,<font color="#666666">"${USERNAME}"</font>,0};
<a name="line639">639: </a>  const char     *r[] = {PETSC_ARCH,PETSC_DIR,PETSC_LIB_DIR,0,0,0,0,0};
<a name="line640">640: </a>  <A href="../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     flag;

<a name="line643">643: </a>  <font color="#4169E1">if</font> (!a || !b) <A href="../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_NULL,<font color="#666666">"a and b strings must be nonnull"</font>);
<a name="line644">644: </a>  <font color="#4169E1">if</font> (aa == b) {
<a name="line645">645: </a>    <A href="../../../docs/manualpages/Sys/PetscStrallocpy.html#PetscStrallocpy">PetscStrallocpy</A>(aa,(char **)&amp;a);
<a name="line646">646: </a>  }
<a name="line647">647: </a>  <A href="../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(len*<font color="#4169E1">sizeof</font>(char*),&amp;work);

<a name="line649">649: </a>  <font color="#B22222">/* get values for replaced variables */</font>
<a name="line650">650: </a>  <A href="../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(256*<font color="#4169E1">sizeof</font>(char),&amp;r[4]);
<a name="line651">651: </a>  <A href="../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(PETSC_MAX_PATH_LEN*<font color="#4169E1">sizeof</font>(char),&amp;r[5]);
<a name="line652">652: </a>  <A href="../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(PETSC_MAX_PATH_LEN*<font color="#4169E1">sizeof</font>(char),&amp;r[6]);
<a name="line653">653: </a>  <A href="../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(256*<font color="#4169E1">sizeof</font>(char),&amp;r[7]);
<a name="line654">654: </a>  PetscGetDisplay((char*)r[4],256);
<a name="line655">655: </a>  <A href="../../../docs/manualpages/Sys/PetscGetHomeDirectory.html#PetscGetHomeDirectory">PetscGetHomeDirectory</A>((char*)r[5],PETSC_MAX_PATH_LEN);
<a name="line656">656: </a>  <A href="../../../docs/manualpages/Sys/PetscGetWorkingDirectory.html#PetscGetWorkingDirectory">PetscGetWorkingDirectory</A>((char*)r[6],PETSC_MAX_PATH_LEN);
<a name="line657">657: </a>  <A href="../../../docs/manualpages/Sys/PetscGetUserName.html#PetscGetUserName">PetscGetUserName</A>((char*)r[7],256);

<a name="line659">659: </a>  <font color="#B22222">/* replace the requested strings */</font>
<a name="line660">660: </a>  <A href="../../../docs/manualpages/Sys/PetscStrncpy.html#PetscStrncpy">PetscStrncpy</A>(b,a,len);
<a name="line661">661: </a>  <font color="#4169E1">while</font> (s[i]) {
<a name="line662">662: </a>    <A href="../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(s[i],&amp;l);
<a name="line663">663: </a>    <A href="../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(b,s[i],&amp;par);
<a name="line664">664: </a>    <font color="#4169E1">while</font> (par) {
<a name="line665">665: </a>      *par  =  0;
<a name="line666">666: </a>      par  += l;

<a name="line668">668: </a>      <A href="../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(b,&amp;l1);
<a name="line669">669: </a>      <A href="../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(r[i],&amp;l2);
<a name="line670">670: </a>      <A href="../../../docs/manualpages/Sys/PetscStrlen.html#PetscStrlen">PetscStrlen</A>(par,&amp;l3);
<a name="line671">671: </a>      <font color="#4169E1">if</font> (l1 + l2 + l3 &gt;= len) {
<a name="line672">672: </a>        <A href="../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_SIZ,<font color="#666666">"b len is not long enough to hold new values"</font>);
<a name="line673">673: </a>      }
<a name="line674">674: </a>      <A href="../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(work,b);
<a name="line675">675: </a>      <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(work,r[i]);
<a name="line676">676: </a>      <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(work,par);
<a name="line677">677: </a>      <A href="../../../docs/manualpages/Sys/PetscStrncpy.html#PetscStrncpy">PetscStrncpy</A>(b,work,len);
<a name="line678">678: </a>      <A href="../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(b,s[i],&amp;par);
<a name="line679">679: </a>    }
<a name="line680">680: </a>    i++;
<a name="line681">681: </a>  }
<a name="line682">682: </a>  <font color="#4169E1">for</font> ( i=4; i&lt;8; i++){
<a name="line683">683: </a>    tfree = (char*)r[i];
<a name="line684">684: </a>    <A href="../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(tfree);
<a name="line685">685: </a>  }

<a name="line687">687: </a>  <font color="#B22222">/* look for any other ${xxx} strings to replace from environmental variables */</font>
<a name="line688">688: </a>  <A href="../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(b,<font color="#666666">"${"</font>,&amp;par);
<a name="line689">689: </a>  <font color="#4169E1">while</font> (par) {
<a name="line690">690: </a>    *par = 0;
<a name="line691">691: </a>    par += 2;
<a name="line692">692: </a>    <A href="../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(work,b);
<a name="line693">693: </a>    <A href="../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(par,<font color="#666666">"}"</font>,&amp;epar);
<a name="line694">694: </a>    *epar = 0;
<a name="line695">695: </a>    epar += 1;
<a name="line696">696: </a>    <A href="../../../docs/manualpages/Sys/PetscOptionsGetenv.html#PetscOptionsGetenv">PetscOptionsGetenv</A>(<A href="../../../docs/manualpages/Sys/comm.html#comm">comm</A>,par,env,256,&amp;flag);
<a name="line697">697: </a>    <font color="#4169E1">if</font> (!flag) {
<a name="line698">698: </a>      <A href="../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_ARG_WRONG,<font color="#666666">"Substitution string ${%s} not found as environmental variable"</font>,par);
<a name="line699">699: </a>    }
<a name="line700">700: </a>    <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(work,env);
<a name="line701">701: </a>    <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(work,epar);
<a name="line702">702: </a>    <A href="../../../docs/manualpages/Sys/PetscStrcpy.html#PetscStrcpy">PetscStrcpy</A>(b,work);
<a name="line703">703: </a>    <A href="../../../docs/manualpages/Sys/PetscStrstr.html#PetscStrstr">PetscStrstr</A>(b,<font color="#666666">"${"</font>,&amp;par);
<a name="line704">704: </a>  }
<a name="line705">705: </a>  <A href="../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(work);
<a name="line706">706: </a>  <font color="#4169E1">if</font> (aa == b) {
<a name="line707">707: </a>    <A href="../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(a);
<a name="line708">708: </a>  }
<a name="line709">709: </a>  <font color="#4169E1">return</font>(0);
<a name="line710">710: </a>}

<a name="line712">712: </a><font color="#B22222">/*MC</font>
<a name="line713">713: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscStrfree.html#PetscStrfree">PetscStrfree</A> - Frees a string (if it is not null)</font>

<a name="line715">715: </a><font color="#B22222">   Not Collective</font>

<a name="line717">717: </a><font color="#B22222">   Synopsis:</font>
<a name="line718">718: </a><font color="#B22222">   <A href="../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> <A href="../../../docs/manualpages/Sys/PetscStrfree.html#PetscStrfree">PetscStrfree</A>(char *s)</font>

<a name="line720">720: </a><font color="#B22222">   Input Parameter:</font>
<a name="line721">721: </a><font color="#B22222">.  s - pointer to string</font>

<a name="line723">723: </a><font color="#B22222">   Level: intermediate</font>

<a name="line725">725: </a><font color="#B22222">  Concepts: string free</font>
<a name="line726">726: </a><font color="#B22222">  </font>
<a name="line727">727: </a><font color="#B22222">.seealso: <A href="../../../docs/manualpages/Sys/PetscStrncpy.html#PetscStrncpy">PetscStrncpy</A>(), <A href="../../../docs/manualpages/Sys/PetscStrcat.html#PetscStrcat">PetscStrcat</A>(), <A href="../../../docs/manualpages/Sys/PetscStrncat.html#PetscStrncat">PetscStrncat</A>(), <A href="../../../docs/manualpages/Sys/PetscStrallocpy.html#PetscStrallocpy">PetscStrallocpy</A>()</font>

<a name="line729">729: </a><font color="#B22222">M*/</font>
</pre>
</body>

</html>
